package com.hzu.bookingsystem.service.impl;

import com.hzu.bookingsystem.converter.UserBean2UserDTO;
import com.hzu.bookingsystem.dto.UserDTO;
import com.hzu.bookingsystem.bean.UserBean;
import com.hzu.bookingsystem.repository.UserRepository;
import com.hzu.bookingsystem.service.UserService;
import com.hzu.bookingsystem.utils.MD5Util;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.transaction.Transactional;
import java.util.List;
/**
 * author 吴志岳
 */
@Service
public class UserServiceImpl implements UserService {
    @Resource
    private UserRepository userRepository;

    @Override
    public UserBean add(UserBean user) {
        // 1.保证ID为空
        user.setUId(null);
        // 2.加密密码
        user.setPassword(MD5Util.md5Encrypt32Upper(user.getPassword()));
        return userRepository.save(user);
    }

    @Override
    public List<UserBean> findAll() {
        return userRepository.findAll();
    }

    @Override
    public UserBean findById(Integer uId) {
        return userRepository.findByUId(uId);
    }

    @Override
    public UserBean findByUserame(String username) {
        return userRepository.findByUsername(username);
    }

    @Override
    public UserBean update(UserBean user) {
        return userRepository.save(user);
    }

    @Override
    @Transactional
    public void deleteById(Integer uId) {
        userRepository.deleteByUId(uId);
    }

    @Override
    public UserBean findByUnameAndPwd(String username, String password) {
        // 加密密码
        password = MD5Util.md5Encrypt32Upper(password);

        return userRepository.findByUsernameAndPassword(username,password);
    }

    @Override
    public List<UserDTO> findAllUserInfo() {
        List<UserBean> userBeanList = userRepository.findAll();
        return UserBean2UserDTO.convert(userBeanList);
    }
}
